Index: .hgsubstate
===================================================================
--- .hgsubstate	(revision 1225)
+++ .hgsubstate	(revision 1102)
@@ -1,1 +1,1 @@
-e2e1a2c966318f4c5ea67f3c3de72ae0ac79b333 inc/libs/clearbricks
+789e7f2b4844160f4dc7d2795cfa1e6f4fd53a5c inc/libs/clearbricks
Index: .hgtags
===================================================================
--- .hgtags	(revision 1219)
+++ .hgtags	(revision 871)
@@ -12,3 +12,2 @@
 6fce226121140735a51a8f447c80f1dacd2974ea 2.4.4
 514d5121a12586b7ff320924d44028b677a01020 2.4.4
-baf879af43beea9764d920c2facd7226e90c5cf3 2.5.1
Index: CHANGELOG
===================================================================
--- CHANGELOG	(revision 1216)
+++ CHANGELOG	(revision 1114)
@@ -1,11 +1,2 @@
-Dotclear 2.5.1 - 2013-07-20
-===========================================================
-* Security fix: Replacement of swfupload.swf by a jQuery plugin
-* Security enhancement: Strenghened lists display
-* Thumbnails quality improved
-* Minor enhancements
-* Various bug fixes
-* Various cosmetic adjustments
-
 Dotclear 2.5.0 - 2013-03-12
 ===========================================================
Index: admin/auth.php
===================================================================
--- admin/auth.php	(revision 1179)
+++ admin/auth.php	(revision 794)
@@ -4,5 +4,5 @@
 # This file is part of Dotclear 2.
 #
-# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
Index: admin/blog.php
===================================================================
--- admin/blog.php	(revision 1179)
+++ admin/blog.php	(revision 565)
@@ -4,5 +4,5 @@
 # This file is part of Dotclear 2.
 #
-# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
Index: admin/blog_del.php
===================================================================
--- admin/blog_del.php	(revision 1179)
+++ admin/blog_del.php	(revision 500)
@@ -4,5 +4,5 @@
 # This file is part of Dotclear 2.
 #
-# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
Index: admin/blog_pref.php
===================================================================
--- admin/blog_pref.php	(revision 1179)
+++ admin/blog_pref.php	(revision 1073)
@@ -4,5 +4,5 @@
 # This file is part of Dotclear 2.
 #
-# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
Index: admin/blog_theme.php
===================================================================
--- admin/blog_theme.php	(revision 1179)
+++ admin/blog_theme.php	(revision 907)
@@ -4,5 +4,5 @@
 # This file is part of Dotclear 2.
 #
-# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
Index: admin/blogs.php
===================================================================
--- admin/blogs.php	(revision 1179)
+++ admin/blogs.php	(revision 907)
@@ -4,5 +4,5 @@
 # This file is part of Dotclear 2.
 #
-# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
Index: admin/categories.php
===================================================================
--- admin/categories.php	(revision 1179)
+++ admin/categories.php	(revision 1030)
@@ -4,5 +4,5 @@
 # This file is part of Dotclear 2.
 #
-# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
Index: admin/category.php
===================================================================
--- admin/category.php	(revision 1179)
+++ admin/category.php	(revision 907)
@@ -4,5 +4,5 @@
 # This file is part of Dotclear 2.
 #
-# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
Index: admin/comment.php
===================================================================
--- admin/comment.php	(revision 1179)
+++ admin/comment.php	(revision 907)
@@ -4,5 +4,5 @@
 # This file is part of Dotclear 2.
 #
-# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
Index: admin/comments.php
===================================================================
--- admin/comments.php	(revision 1179)
+++ admin/comments.php	(revision 1054)
@@ -4,5 +4,5 @@
 # This file is part of Dotclear 2.
 #
-# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
@@ -225,11 +225,13 @@
 	'</form>';
 	
-	$spam_count = $core->blog->getComments(array('comment_status'=>-2),true)->f(0);
-	if ($spam_count > 0) {
+	if (!$with_spam) {
+
+		$spam_count = $core->blog->getComments(array('comment_status'=>-2),true)->f(0);
 		
-		echo 
-			'<form action="comments.php" method="post" class="fieldset">';
-
-		if (!$with_spam || ($status != -2)) {
+		if ($spam_count > 0) {
+			
+			echo 
+				'<form action="comments.php" method="post" class="fieldset">';
+
 			if ($spam_count == 1) {
 				echo '<p>'.sprintf(__('You have one spam comments.'),'<strong>'.$spam_count.'</strong>').' '.
@@ -239,14 +241,14 @@
 				'<a href="comments.php?status=-2">'.__('Show them.').'</a></p>';
 			}
+			
+			echo
+				$core->formNonce().
+				'<input name="delete_all_spam" class="delete" type="submit" value="'.__('Delete all spams').'" /></p>';
+
+			# --BEHAVIOR-- adminCommentsSpamForm
+			$core->callBehavior('adminCommentsSpamForm',$core);
+
+			echo '</form>';
 		}
-		
-		echo
-			$core->formNonce().
-			'<input name="delete_all_spam" class="delete" type="submit" value="'.__('Delete all spams').'" /></p>';
-
-		# --BEHAVIOR-- adminCommentsSpamForm
-		$core->callBehavior('adminCommentsSpamForm',$core);
-
-		echo '</form>';
 	}
 	
Index: admin/comments_actions.php
===================================================================
--- admin/comments_actions.php	(revision 1179)
+++ admin/comments_actions.php	(revision 1041)
@@ -4,5 +4,5 @@
 # This file is part of Dotclear 2.
 #
-# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
Index: admin/index.php
===================================================================
--- admin/index.php	(revision 1179)
+++ admin/index.php	(revision 1077)
@@ -4,5 +4,5 @@
 # This file is part of Dotclear 2.
 #
-# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
Index: admin/install/check.php
===================================================================
--- admin/install/check.php	(revision 1179)
+++ admin/install/check.php	(revision 270)
@@ -4,5 +4,5 @@
 # This file is part of Dotclear 2.
 #
-# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
Index: admin/install/index.php
===================================================================
--- admin/install/index.php	(revision 1179)
+++ admin/install/index.php	(revision 557)
@@ -4,5 +4,5 @@
 # This file is part of Dotclear 2.
 #
-# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
@@ -198,5 +198,5 @@
 		# Add user interface options
 		$core->auth->user_prefs->addWorkspace('interface');
-		$core->auth->user_prefs->interface->put('enhanceduploader',true,'boolean','',null,true);
+		$core->auth->user_prefs->interface->put('enhanceduploader',false,'boolean','',null,true);
 
 		# Add default favorites
Index: admin/install/wizard.php
===================================================================
--- admin/install/wizard.php	(revision 1179)
+++ admin/install/wizard.php	(revision 858)
@@ -4,5 +4,5 @@
 # This file is part of Dotclear 2.
 #
-# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
Index: admin/js/_blog_pref.js
===================================================================
--- admin/js/_blog_pref.js	(revision 1136)
+++ admin/js/_blog_pref.js	(revision 175)
@@ -10,5 +10,5 @@
 	$("p#urlwarning").remove();
 	if (errorMsg != '') {
-		$("#blog_url").parents('p').after('<p id="urlwarning" class="warning">'+errorMsg+'</p>');
+		$("#blog_url").parents('p').before('<p id="urlwarning" class="error">'+errorMsg+'</p>');
 	}
 }
Index: admin/js/_index.js
===================================================================
--- admin/js/_index.js	(revision 1140)
+++ admin/js/_index.js	(revision 454)
@@ -66,4 +66,4 @@
 	$('#quick h3').toggleWithLegend($('#quick').children().not('h3'),{
 		cookie: 'dcx_quick_entry'
-	});
+	}, positionFooter);
 });
Index: admin/js/_media.js
===================================================================
--- admin/js/_media.js	(revision 1191)
+++ admin/js/_media.js	(revision 1039)
@@ -1,85 +1,8 @@
 $(function() {
-	if ($('#fileupload').length==0) {
-		return;
-	}
-
-	$('.button.add').click(function(e) {
-		// Use the native click() of the file input.
-		$('#upfile').click();
-		e.preventDefault();
-	});
-
-	$('.button.cancel', '#fileupload').click(function(e) {
-		$('.button.cancel, .button.start','#fileupload .fileupload-buttonbar').hide();
-	});
-
-	$('.button.clean', '#fileupload').click(function(e) {
-		$('.fileupload-ctrl .files .template-download', '#fileupload').slideUp(500, function() {
-			$(this).remove();
-		});
-		$(this).hide();
-		e.preventDefault();
-	});
-
-	$('#fileupload').fileupload({
-		url: $('#fileupload').attr('action'),
-		autoUpload: false,
-		sequentialUploads: true,
-		disabled: true
-	}).bind('fileuploadadd', function(e, data) {
-		$('.button.cancel, .button.start', '#fileupload .fileupload-buttonbar').show();
-	}).bind('fileuploaddone', function(e, data) {
-		if (data.result.files[0].html !==undefined) {
-			$('.media-list p.clear').before(data.result.files[0].html);
-		}
-		$('.button.clean','#fileupload').show();
-	}).bind('fileuploadalways', function(e, data) {
-	    if ($('.fileupload-ctrl .files .template-upload', '#fileupload').length==0) {
-		$('.button.start, .button.cancel','#fileupload .fileupload-buttonbar').hide();
-	    }
-	});
-
-	var $container = $('#fileupload').parent().parent();
-	var $msg,label;
-
-	if ($container.hasClass('enhanced_uploader')) {
-		$msg = dotclear.msg.enhanced_uploader_disable;
-		label = dotclear.jsUpload.msg.choose_files;
-		$('#fileupload').fileupload({disabled:false});
-	} else {
-		$msg = dotclear.msg.enhanced_uploader_activate;
-		label = dotclear.jsUpload.msg.choose_file;
-	}
-
-	$('<p class="clear"><a class="enhanced-toggle" href="#">' + $msg + '</a></p>').click( function() {
-		if ($container.hasClass('enhanced_uploader')) {
-			$msg = dotclear.msg.enhanced_uploader_activate;
-			label = dotclear.jsUpload.msg.choose_file;
-			$('#upfile').attr('multiple', false);
-
-			// when a user has clicked enhanced_uploader, and has added files
-			// We must remove files in table
-			$('.files .upload-file', '#fileupload').remove();
-			$('.button.cancel, .button.start','#fileupload .fileupload-buttonbar').hide();
-			$('.button.start','#fileupload').show();
-			$('#fileupload').fileupload({disabled:true});
-		} else {
-			$msg = dotclear.msg.enhanced_uploader_disable;
-			label = dotclear.jsUpload.msg.choose_files;
-			$('#upfile').attr('multiple', true);
-			$('.button.start','#fileupload').hide();
-			$('#fileupload').fileupload({disabled:false});
-		}
-		$(this).find('a').text($msg);
-		$('.add-label', '#fileupload').text(label);
-
-		$container.toggleClass('enhanced_uploader');
-	}).appendTo($('#fileupload'));
-
 	// Replace remove links by a POST on hidden form
 	fileRemoveAct();
-
+	
 	function fileRemoveAct() {
-		$('a.media-remove').live('click', function() {
+		$('a.media-remove').click(function() {
 			var m_name = $(this).parents('ul').find('li:first>a').text();
 			if (window.confirm(dotclear.msg.confirm_delete_media.replace('%s',m_name))) {
@@ -92,3 +15,77 @@
 		});
 	}
+	
+	if (!$.browser.opera) {
+		var upldr = $('<a href="#" id="cu-enable">' + dotclear.msg.activate_enhanced_uploader + '</a>').click( function() {
+			candyUploadInit();
+			return false;
+		});
+		$('#media-upload').append($('<div></div>').append(upldr));
+		if ((dotclear.candyUpload_force_init == '1') || (($.cookie('dc_candy_upl') == 1))) {
+			candyUploadInit();
+		}
+	}
+	
+	function candyUploadInit()
+	{
+		var candy_upload_success = false;
+		var candy_upload_form_url = $('#media-upload').attr('action') + '&file_sort=date-desc&d=' + $('#media-upload input[name=d]').val();
+		var candy_upload_limit = $('#media-upload input[name=MAX_FILE_SIZE]').val();
+		$('#media-upload').candyUpload({
+			upload_url: dotclear.candyUpload.base_url + '/media.php',
+			flash_movie: dotclear.candyUpload.movie_url,
+			file_size_limit: candy_upload_limit + 'b',
+			params: 'swfupload=1&amp;' + dotclear.candyUpload.params,
+			
+			callbacks: {
+				createControls: function() {
+					var _this = this;
+					this.ctrl.btn_browse.hide();
+					this.ctrl.msg.html(dotclear.msg.load_enhanced_uploader);
+					var l = $('<a href="#">' + dotclear.msg.disable_enhanced_uploader + '</a>').click(function() {
+						_this.upldr.destroy();
+						_this.ctrl.block.empty().remove();
+						$('#media-upload').show();
+						delete _this;
+						$.cookie('dc_candy_upl','',{expires:-1});
+						return false;
+					});
+					this.ctrl.disable = $('<div class="cu-disable"></div>').append(l).appendTo(this.ctrl.block);
+				},
+				flashReady: function() {
+					var _this = this;
+					this.ctrl.msg.fadeOut('fast',function() {
+						$(this).text(_this.locales.no_file_in_queue).fadeIn('fast');
+						_this.ctrl.btn_browse.fadeIn('fast',function() {
+							_this.upldr.container.children().css({
+								width: $('.cu-btn-browse').width(),
+								height: $('.cu-btn-browse').height()
+							});
+						});
+					});
+				},
+				uploadSuccess: function(o,data) {
+					if (data == 'ok') {
+						candy_upload_success = true;
+						this.fileMsg(o.id,this.locales.file_uploaded);
+					} else {
+						this.fileErrorMsg(o.id,data);
+					}
+					
+					// uploads finished and at least one success
+					if (candy_upload_success && $('div.cu-file:has(span.cu-filecancel a)',this.ctrl.files).length == 0) {
+						$.cookie('dc_candy_upl','1',{expires: 30});
+						$.get(candy_upload_form_url,function(data) {
+							var media = $('div.media-list');
+							media.after($('div.media-list',data)).remove();
+							fileRemoveAct();
+						});
+					}
+				},
+				fileQueued: function() {
+					positionFooter();
+				}
+			}
+		});
+	}
 });
Index: admin/js/_post.js
===================================================================
--- admin/js/_post.js	(revision 1140)
+++ admin/js/_post.js	(revision 740)
@@ -8,5 +8,5 @@
 	$(img).css('cursor','pointer');
 	img.line = line;
-	img.onclick = function() { dotclear.viewCommentContent(this,this.line); };
+	img.onclick = function() { dotclear.viewCommentContent(this,this.line); positionFooter(); };
 	
 	td.insertBefore(img,td.firstChild);
Index: admin/js/common.js
===================================================================
--- admin/js/common.js	(revision 1140)
+++ admin/js/common.js	(revision 1002)
@@ -84,9 +84,9 @@
 			$(i).get(0).src = p.img_on_src;
 			$(i).get(0).alt = p.img_on_alt;
-			target.hide(speed);
+			target.hide(speed, positionFooter);
 		} else {
 			$(i).get(0).src = p.img_off_src;
 			$(i).get(0).alt = p.img_off_alt;
-			target.show(speed);
+			target.show(speed, positionFooter);
 			if (p.fn) {
 				p.fn.apply(target);
@@ -122,5 +122,5 @@
 		$(ctarget).css('cursor','pointer');
 		$(ctarget).click(function() {
-			toggle(i,p.speed);
+			toggle(i,p.speed, positionFooter);
 			return false;
 		});
@@ -315,4 +315,10 @@
 	}
 };
+
+/* Sticky footer
+-------------------------------------------------------- */
+function positionFooter() {
+	$('#footer').constantfooter();
+}
 
 /* On document ready
@@ -359,4 +365,8 @@
 		return true;
 	});
+
+	// Sticky footer
+	positionFooter();
+	$(window).resize(positionFooter);
 });
 
